<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::avsCommon::utils::test::WaitEvent Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common.html">avsCommon</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils.html">utils</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1avs_common_1_1utils_1_1test.html">test</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html">WaitEvent</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-attribs">Static Public Attributes</a> &#124;
<a href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::avsCommon::utils::test::WaitEvent Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_wait_event_8h_source.html">WaitEvent.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a5bdc26a0cc259113189ebc2073daf029"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a5bdc26a0cc259113189ebc2073daf029">WaitEvent</a> ()</td></tr>
<tr class="separator:a5bdc26a0cc259113189ebc2073daf029"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad5435a585e6a1eea6d34c0cd88f65ba1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#ad5435a585e6a1eea6d34c0cd88f65ba1">wakeUp</a> ()</td></tr>
<tr class="separator:ad5435a585e6a1eea6d34c0cd88f65ba1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae90eb3492582fe1bfc0327191dcfebdb"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#ae90eb3492582fe1bfc0327191dcfebdb">wait</a> (const std::chrono::milliseconds &amp;timeout=<a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a07a33a6ae7e5382ee83c7555bf3e3178">DEFAULT_TIMEOUT</a>)</td></tr>
<tr class="separator:ae90eb3492582fe1bfc0327191dcfebdb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56edfba5956d9fe7354a365bf5955726"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a56edfba5956d9fe7354a365bf5955726">reset</a> ()</td></tr>
<tr class="separator:a56edfba5956d9fe7354a365bf5955726"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-attribs"></a>
Static Public Attributes</h2></td></tr>
<tr class="memitem:a07a33a6ae7e5382ee83c7555bf3e3178"><td class="memItemLeft" align="right" valign="top">static const std::chrono::seconds&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a07a33a6ae7e5382ee83c7555bf3e3178">DEFAULT_TIMEOUT</a> {5}</td></tr>
<tr class="memdesc:a07a33a6ae7e5382ee83c7555bf3e3178"><td class="mdescLeft">&#160;</td><td class="mdescRight">The default timeout for an expected event.  <a href="#a07a33a6ae7e5382ee83c7555bf3e3178">More...</a><br /></td></tr>
<tr class="separator:a07a33a6ae7e5382ee83c7555bf3e3178"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Class that can be used to wait for an event.</p>
<p class="">This class is for testing purpose only and each object should only be used once. After the first <code>wakeUp</code> call, any call to <code>wait</code> will no longer block. Use <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a56edfba5956d9fe7354a365bf5955726">reset()</a></code> to reset the internal state and allow wait to block again. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a5bdc26a0cc259113189ebc2073daf029"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5bdc26a0cc259113189ebc2073daf029">&#9670;&nbsp;</a></span>WaitEvent()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::avsCommon::utils::test::WaitEvent::WaitEvent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a56edfba5956d9fe7354a365bf5955726"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a56edfba5956d9fe7354a365bf5955726">&#9670;&nbsp;</a></span>reset()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::test::WaitEvent::reset </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Reset the event occurrence flag. </p>

</div>
</div>
<a id="ae90eb3492582fe1bfc0327191dcfebdb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae90eb3492582fe1bfc0327191dcfebdb">&#9670;&nbsp;</a></span>wait()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::avsCommon::utils::test::WaitEvent::wait </td>
          <td>(</td>
          <td class="paramtype">const std::chrono::milliseconds &amp;&#160;</td>
          <td class="paramname"><em>timeout</em> = <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#a07a33a6ae7e5382ee83c7555bf3e3178">DEFAULT_TIMEOUT</a></code></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Wait for wake up event.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">timeout</td><td>The maximum amount of time to wait for the event. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> if wakeUp has been called within the timeout; <code>false</code> otherwise. </dd></dl>

</div>
</div>
<a id="ad5435a585e6a1eea6d34c0cd88f65ba1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad5435a585e6a1eea6d34c0cd88f65ba1">&#9670;&nbsp;</a></span>wakeUp()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::avsCommon::utils::test::WaitEvent::wakeUp </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Notify all threads that are waiting for this event.</p>
<p class="">This method will also set the <code>m_wakeUpTriggered</code> to <code>true</code> to ensure that the waiting thread will not wait forever in case there is a race condition and <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#ad5435a585e6a1eea6d34c0cd88f65ba1">wakeUp()</a></code> is triggered before the <code><a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1utils_1_1test_1_1_wait_event.html#ae90eb3492582fe1bfc0327191dcfebdb">wait()</a></code>. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a07a33a6ae7e5382ee83c7555bf3e3178"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a07a33a6ae7e5382ee83c7555bf3e3178">&#9670;&nbsp;</a></span>DEFAULT_TIMEOUT</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::chrono::seconds alexaClientSDK::avsCommon::utils::test::WaitEvent::DEFAULT_TIMEOUT {5}</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>The default timeout for an expected event. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/AVSCommon/Utils/test/AVSCommon/Utils/<a class="el" href="_wait_event_8h_source.html">WaitEvent.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
